#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

long long const MAXN=10000001;
long long n, s, h, k, a[MAXN], tree[MAXN], lazy[MAXN];

void make_tree(int idx, int l, int r)
{
    if(l == r)
    {
        tree[idx] = h;
        return;
    }
    int mid = (l+r)/2;
    make_tree(idx*2, l, mid);
    make_tree(idx*2+1, mid+1, r);
    tree[idx] = tree[idx*2] + tree[idx*2+1];
}

void push_lazy(long long idx, long long l, long long r)
{
    if(lazy[idx] != 0)
    {
        tree[idx] -= (r-l+1)*lazy[idx];
        if(l != r)
        {
            lazy[idx*2+1] += lazy[idx];
            lazy[idx*2] += lazy[idx];
        }
        lazy[idx] = 0;
    }
}

void lazy_propagation(long long idx, long long l, long long r, long long ql, long long qr, long long val)
{
    push_lazy(idx, l, r);
    if(ql > r || qr < l || l > r) return;
    if(ql <= l && qr >= r)
    {
        lazy[idx] += val;
        push_lazy(idx, l, r);
        return;
    }
    int mid = (l+r)/2;
    lazy_propagation(idx*2, l, mid, ql, qr, val);
    lazy_propagation(idx*2+1, mid+1, r, ql, qr, val);
    tree[idx] = tree[idx*2] + tree[idx*2+1];
}

void query(int idx, int l, int r)
{
    push_lazy(idx, l, r);
    if(l == r)
    {
        tree[idx] = max((long long)0, tree[idx]);
        return;
    }
    int mid = (l+r)/2;
    query(idx*2, l, mid);
    query(idx*2+1, mid+1, r);
    tree[idx] = tree[idx*2] + tree[idx*2+1];
}

void read()
{
    long long x, y, d;
    cin>>n>>s>>h>>k;
    make_tree(1,1,s);
    for(long long i=1;i<=n;i++)
    {
        cin>>x>>y>>d;
        lazy_propagation(1,1,s,x,y,d);
    }
    query(1,1,s);
    cout<<s*h - tree[1]<<endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
